﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Windows.Devices.Gpio;


namespace GPIO_ToggleLED
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    /// 

    public partial class MainWindow : Window
    {

        private GpioPin myPin;
        private const int GPIO_LED_PIN = 0;

#pragma warning disable CS8618 // Non-nullable field must contain a non-null value when exiting constructor. Consider declaring as nullable.
        public MainWindow()
#pragma warning restore CS8618 // Non-nullable field must contain a non-null value when exiting constructor. Consider declaring as nullable.
        {
            InitializeComponent();
            GPIOSetUp();
        }

        public void GPIOSetUp()
        {
            GpioController myGPIOController = GpioController.GetDefault();            
            if (myGPIOController == null)
            {
                txtStatus.Text = "GPIO controller NOT found";
            }
            else
            {
                try
                {
                    myPin = myGPIOController.OpenPin(GPIO_LED_PIN);
                }
                catch (Exception ex)
                {
                    txtStatus.Text = "Error!: " + ex.ToString();
                }
                if (myPin == null)
                {
                    txtStatus.Text = "GPIO " + GPIO_LED_PIN.ToString() + " not found";
                }
                else
                {
                    try
                    {
                        myPin.SetDriveMode(GpioPinDriveMode.Output);
                        myPin.Write(GpioPinValue.High);
                        txtStatus.Text = "GPIO is ready";
                    }
                    catch (Exception ex)
                    {
                        txtStatus.Text = "Error!: " + ex.ToString();
                    }
                }
            }
        }

        private void btnToggle_Click(object sender, RoutedEventArgs e)
        {
            if (myPin.Read() == GpioPinValue.High)
            {
                myPin.Write(GpioPinValue.Low);
            }
            else
            {
                myPin.Write(GpioPinValue.High);
            }
        }
    }
}
