﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Windows.Devices.SerialCommunication;
using Windows.Devices.Enumeration;
using Windows.Storage.Streams;


namespace UART_SerLCD
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private async void btnSend_Click(object sender, RoutedEventArgs e)
        {
            string aqs = SerialDevice.GetDeviceSelector("UART1");
            DeviceInformationCollection deviceInfo = await DeviceInformation.FindAllAsync(aqs);
            SerialDevice myCom1 = await SerialDevice.FromIdAsync(deviceInfo[0].Id);

            byte[] LCDCLEAR = new byte[] { 0xFE, 0x01 };
            byte[] LCDLINE1 = new byte[] { 0xFE, 0x80 };
            byte[] LCDLINE2 = new byte[] { 0xFE, 0xC0 };
            byte[] LCDMOVECURR1 = new byte[] { 0xFE, 0x14 };
            byte[] LCDMOVECURL1 = new byte[] { 0xFE, 0x10 };
            byte[] LCDSCROLLRIGHT = new byte[] { 0xFE, 0x1C };
            byte[] LCDSCROLLLEFT = new byte[] { 0xFE, 0x18 };
            byte[] LCDVISUALON = new byte[] { 0xFE, 0x0C };
            byte[] LCDVISUALOFF = new byte[] { 0xFE, 0x08 };
            byte[] LCDCURON = new byte[] { 0xFE, 0x0E };
            byte[] LCDCUROFF = new byte[] { 0xFE, 0x0C };
            byte[] LCDBLINKON = new byte[] { 0xFE, 0x0D };
            byte[] LCDBLINKOFF = new byte[] { 0xFE, 0x0C };


            if (myCom1 == null)
            {
                txtMessage.Text += "Error1";
            }
            else
            {
                myCom1.BaudRate = 9600;
                myCom1.DataBits = 8;
                myCom1.Parity = SerialParity.None;
                myCom1.StopBits = SerialStopBitCount.One;
                myCom1.Handshake = SerialHandshake.None;

                DataWriter dataWriter = new DataWriter(myCom1.OutputStream);
                dataWriter.WriteBytes(LCDCLEAR);
                await dataWriter.StoreAsync();
                dataWriter.WriteBytes(LCDCURON);
                await dataWriter.StoreAsync();
                dataWriter.WriteBytes(LCDBLINKON);
                await dataWriter.StoreAsync();
                dataWriter.WriteString(txtMessage.Text.ToString());
                await dataWriter.StoreAsync();
                dataWriter.WriteBytes(LCDLINE2);
                await dataWriter.StoreAsync();
                dataWriter.WriteString("Win10 IoT E");
                await dataWriter.StoreAsync();
                dataWriter.DetachStream();
                myCom1.Dispose();
            }

        }
    }
}
