﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Annabooks.SHTC3;
using System.Threading;

namespace I2CHumiditySensor
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        SHTC3 mySHTC3;

#pragma warning disable CS8618 // Non-nullable field must contain a non-null value when exiting constructor. Consider declaring as nullable.
        public MainWindow()
#pragma warning restore CS8618 // Non-nullable field must contain a non-null value when exiting constructor. Consider declaring as nullable.
        {
            InitializeComponent();
            Thread setupHumiditySensor = new Thread(new ThreadStart(HumiditySensorSetup));
            setupHumiditySensor.Start();

        }

        private void HumiditySensorSetup()
        {
            mySHTC3 = new SHTC3("I2C1", false);
            Thread.Sleep(1100);
            if (mySHTC3.HTU21DStatus())
            {
                Application.Current.Dispatcher.Invoke((Action)(() => txtStatus.Text = "Humidity Sensor is Ready"));
            }
            else
            {
                Application.Current.Dispatcher.Invoke((Action)(() => txtStatus.Text = "Humidity Sensor is NOT Ready: " + mySHTC3.connectionError));
            }
        }

        private void btnGetData_Click(object sender, RoutedEventArgs e)
        {
            if (mySHTC3.HTU21DStatus())
            {
                txtHumidity.Text = mySHTC3.ReadHumidity().ToString();
                txtTemp.Text = mySHTC3.ReadTempC().ToString();
            }
        }
    }
}
