﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Annabooks.TMP102;
using System.Threading;

namespace I2CTempSensor2
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        TMP102 myTemp;
#pragma warning disable CS8618 // Non-nullable field must contain a non-null value when exiting constructor. Consider declaring as nullable.
        public MainWindow()
#pragma warning restore CS8618 // Non-nullable field must contain a non-null value when exiting constructor. Consider declaring as nullable.
        {
            InitializeComponent();
            Thread temptStatus = new Thread(new ThreadStart(TempSetup));
            temptStatus.Start();
        }

        private void TempSetup()
        {
            myTemp = new TMP102("I2C1", false, 0x48);
            Thread.Sleep(2000);
            if (myTemp.TMP102Status())
            {
                Application.Current.Dispatcher.Invoke((Action)(() => txtStatus.Text = "Temp Sensor is Ready"));
            }
            else
            {
                Application.Current.Dispatcher.Invoke((Action)(() => txtStatus.Text = "Temp Sensor is NOT Ready: " + myTemp.connectionError));
            }
        }

        private void btnReadTemp_Click(object sender, RoutedEventArgs e)
        {
            if (myTemp.TMP102Status())
            {
                txtTempCReading.Text = myTemp.ReadTempC().ToString();
                txtTempFReading.Text = myTemp.ReadTempF().ToString();
            }
        }
    }
}
