﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Windows.Devices.Enumeration;
using Windows.Devices.Pwm;

namespace PWMMotor
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        private PwmController myPWMController;
        private PwmPin myPWM;

#pragma warning disable CS8618 // Non-nullable field must contain a non-null value when exiting constructor. Consider declaring as nullable.
        public MainWindow()
#pragma warning restore CS8618 // Non-nullable field must contain a non-null value when exiting constructor. Consider declaring as nullable.
        {
            InitializeComponent();
            InitPWM();
        }

        public async void InitPWM()
        {
            try
            {
                string aqs = PwmController.GetDeviceSelector("PWM3");
                DeviceInformationCollection deviceInfoPWM = await DeviceInformation.FindAllAsync(aqs);
                myPWMController = await PwmController.FromIdAsync(deviceInfoPWM[0].Id);
                txtPinCount.Text = myPWMController.PinCount.ToString();
                txtMinFreq.Text = myPWMController.MinFrequency.ToString();
                txtMaxFreq.Text = myPWMController.MaxFrequency.ToString();
                myPWM = myPWMController.OpenPin(0);
            }
            catch (Exception ex)
            {
                txtStatus.Text = ex.ToString();
            }
        }

        private void btnStart_Click(object sender, RoutedEventArgs e)
        {
            try
            {
                myPWM.Start();
                myPWM.SetActiveDutyCyclePercentage(0.4);
                myPWMController.SetDesiredFrequency(30.0);
                txtDutyCycle.Text = myPWM.GetActiveDutyCyclePercentage().ToString();
                txtFreq.Text = myPWMController.ActualFrequency.ToString();
            }
            catch (Exception ex)
            {
                txtStatus.Text = ex.ToString();
            }
        }

        private void btnStop_Click(object sender, RoutedEventArgs e)
        {
            try
            {
                myPWM.Stop();
                txtDutyCycle.Text = "0";
                txtFreq.Text = "0";
            }
            catch (Exception ex)
            {
                txtStatus.Text = ex.ToString();
            }

        }
    }
}
